// testIDM1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#import "IDManTypeInfo.tlb" 
#include "IDManTypeInfo.h"		
#include "IDManTypeInfo_i.c"	

#include <atlbase.h>	//for CComBSTR class

int main(int argc, char* argv[])
{
	char testUrl[] = "http://www.internetdownloadmanager.com/trans_kit.zip";

	CComBSTR referer = L"http://www.tonec.com/";
	CComBSTR pbstrUA = L"TestIDM User-Agent";

	CoInitialize(NULL);

	ICIDMLinkTransmitter2* pIDM;
	HRESULT hr = CoCreateInstance(CLSID_CIDMLinkTransmitter, NULL, CLSCTX_LOCAL_SERVER, IID_ICIDMLinkTransmitter2, (void**)&pIDM);
	if (S_OK == hr)
	{
		//one of conversion examples from char* to BSTR (you could also define CComBSTR bstrHref = "http://www.internetdownloadmanager.com/trans_kit.zip";)
		int len;
		if (len = MultiByteToWideChar(CP_ACP, 0, testUrl, -1, NULL, 0))
		{
			BSTR bstrHref;
			if (bstrHref = SysAllocStringLen(NULL, len))
			{
				MultiByteToWideChar(CP_ACP, 0, testUrl, -1, bstrHref, len);

				VARIANT var1, var2;
				VariantInit(&var1);
				VariantInit(&var2);
				if (pbstrUA)
				{
					var1.vt = VT_BSTR;
					var1.bstrVal = pbstrUA;
				}
				else
					var1.vt = VT_EMPTY;
				var2.vt = VT_EMPTY;

				hr = pIDM->SendLinkToIDM2(bstrHref, referer, NULL, NULL, 
					NULL, NULL, NULL, NULL, 0, var1, var2);

				if (S_OK != hr)
				{
					//.........
				}

				SysFreeString(bstrHref);
			}
		}

		pIDM->Release();
	}

	CoUninitialize();

	return 0;
}

